//+------------------------------------------------------------------+
//|                                           Awesome 4 color v1.mq4 |
//|                      originalAwesome 4 color modfications by cja |
//|                      modified for alerts by mrtools              |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers 7
#property  indicator_color1  clrSilver
#property  indicator_color2  clrLimeGreen
#property  indicator_color3  clrGreen
#property  indicator_color4  clrRed
#property  indicator_color5  clrMaroon
#property  indicator_color6  clrChartreuse
#property  indicator_color7  clrSandyBrown
#property  indicator_width2  4
#property  indicator_width3  4
#property  indicator_width4  4
#property  indicator_width5  4
#property  indicator_width6  3
#property  indicator_width7  3

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame         = PERIOD_CURRENT;
extern ENUM_MA_METHOD     MaMethod1         = MODE_SMA;
extern int                MaPeriod1         = 5;
extern ENUM_APPLIED_PRICE MaPrice1          = PRICE_MEDIAN;
extern ENUM_MA_METHOD     MaMethod2         = MODE_SMA;
extern int                MaPeriod2         = 34;
extern ENUM_APPLIED_PRICE MaPrice2          = PRICE_MEDIAN;
extern int                SignalPeriod      = 9;
extern bool               alertsOn          = true;
extern bool               alertsOnZeroCross = true;
extern bool               alertsOnSlope     = true;
extern bool               alertsOnCurrent   = false;
extern bool               alertsMessage     = true;
extern bool               alertsSound       = false;
extern bool               alertsNotify      = false;
extern bool               alertsEmail       = false;
extern string             soundFile         = "alert2.wav";
extern bool               Interpolate       = true;
extern bool               HistogramOnSlope  = true;
//
//
//
//
//

double ao[];
double aohuu[];
double aohud[];
double aohdd[];
double aohdu[];
double slope[];
double trend[];
double signalu[];
double signald[];
string indicatorFileName;
bool   returnBars;

//
//
//
//
//

int init()
{
   IndicatorBuffers(9);   
   SetIndexBuffer(0,ao);    SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,aohuu); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,aohud); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,aohdd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,aohdu); SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexBuffer(5,signalu);
   SetIndexBuffer(6,signald);
   SetIndexBuffer(7,slope);
   SetIndexBuffer(8,trend);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   
      //
      //
      //
      //
      //

   IndicatorShortName(timeFrameToString(TimeFrame)+" Awesome 4 colors");
return(0);
}

int deinit()
{

return(0);
}

//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ao[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
     double alpha = 2.0/(1.0+SignalPeriod);       
     for(i=limit; i>=0; i--) ao[i] = iMA(NULL,0,MaPeriod1,0,MaMethod1,MaPrice1,i)-iMA(NULL,0,MaPeriod2,0,MaMethod2,MaPrice2,i);
     for(i=limit; i>=0; i--)
     {
        aohuu[i] = EMPTY_VALUE;
        aohud[i] = EMPTY_VALUE;
        aohdd[i] = EMPTY_VALUE;
        aohdu[i] = EMPTY_VALUE;
        slope[i] = slope[i+1];
        trend[i] = trend[i+1];
           if (ao[i] > 0)       trend[i] =  1;
           if (ao[i] < 0)       trend[i] = -1;
           if (ao[i] > ao[i+1]) slope[i] =  1;
           if (ao[i] < ao[i+1]) slope[i] = -1;
           if (i<Bars-1)
           {
              if (ao[i] > 0) signalu[i] = signalu[i+1]+alpha*(ao[i]-signalu[i+1]); else signalu[i]=signalu[i+1];
              if (ao[i] < 0) signald[i] = signald[i+1]+alpha*(ao[i]-signald[i+1]); else signald[i]=signald[i+1];
           }
           else
           {
              signalu[i] = 0; signald[i] = 0;
           }            
            
           if (HistogramOnSlope)
           {
             if (trend[i] ==  1 && slope[i] ==  1 && ao[i] >= signalu[i]) aohuu[i] = ao[i];
             if (trend[i] ==  1 && slope[i] == -1 && ao[i] >= signalu[i]) aohud[i] = ao[i];
             if (trend[i] == -1 && slope[i] == -1 && ao[i] <= signald[i]) aohdd[i] = ao[i];
             if (trend[i] == -1 && slope[i] ==  1 && ao[i] <= signald[i]) aohdu[i] = ao[i];
           }
           else
           {                  
             if (trend[i] ==  1 && ao[i] >= signalu[i]) aohuu[i] = ao[i];
             if (trend[i] == -1 && ao[i] <= signald[i]) aohdd[i] = ao[i];
           }
      }
      
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;  

        //
        //
        //
        //
        //
            
        static datetime time1 = 0;
        static string   mess1 = "";
        if (alertsOnZeroCross && trend[whichBar] != trend[whichBar+1])
        {
           if (trend[whichBar] ==  1) doAlert(time1,mess1,whichBar,"crossing zero up");
           if (trend[whichBar] == -1) doAlert(time1,mess1,whichBar,"crossing zero down");
        }
      
        static datetime time2 = 0;
        static string   mess2 = "";
        if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
        {
           if (slope[whichBar] ==  1) doAlert(time2,mess2,whichBar,"sloping up");
           if (slope[whichBar] == -1) doAlert(time2,mess2,whichBar,"sloping down");
        }
    }    
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         ao[i]      = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MaMethod1,MaPeriod1,MaPrice1,MaMethod2,MaPeriod2,MaPrice2,SignalPeriod,alertsOn,alertsOnZeroCross,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
         aohuu[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MaMethod1,MaPeriod1,MaPrice1,MaMethod2,MaPeriod2,MaPrice2,SignalPeriod,alertsOn,alertsOnZeroCross,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);
         aohud[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MaMethod1,MaPeriod1,MaPrice1,MaMethod2,MaPeriod2,MaPrice2,SignalPeriod,alertsOn,alertsOnZeroCross,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,2,y);
         aohdd[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MaMethod1,MaPeriod1,MaPrice1,MaMethod2,MaPeriod2,MaPrice2,SignalPeriod,alertsOn,alertsOnZeroCross,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,3,y);
         aohdu[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MaMethod1,MaPeriod1,MaPrice1,MaMethod2,MaPeriod2,MaPrice2,SignalPeriod,alertsOn,alertsOnZeroCross,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,4,y);
         signalu[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MaMethod1,MaPeriod1,MaPrice1,MaMethod2,MaPeriod2,MaPrice2,SignalPeriod,alertsOn,alertsOnZeroCross,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,5,y);
         signald[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MaMethod1,MaPeriod1,MaPrice1,MaMethod2,MaPeriod2,MaPrice2,SignalPeriod,alertsOn,alertsOnZeroCross,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,6,y);
         
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;
         
             //
             //
             //
             //
             //

             datetime time = iTime(NULL,TimeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  ao[i+k]      = ao[i]      + (ao[i+n]      - ao[i])      * k/n;
                  signalu[i+k] = signalu[i] + (signalu[i+n] - signalu[i]) * k/n;
                  signald[i+k] = signald[i] + (signald[i+n] - signald[i]) * k/n;
                    if (aohuu[i]!= EMPTY_VALUE) aohuu[i+k] = ao[i+k];
                    if (aohud[i]!= EMPTY_VALUE) aohud[i+k] = ao[i+k];
                    if (aohdd[i]!= EMPTY_VALUE) aohdd[i+k] = ao[i+k];
                    if (aohdu[i]!= EMPTY_VALUE) aohdu[i+k] = ao[i+k];
               }
      }
return(0);
}        

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Awesome ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Awesome "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

